local count = 0
local quiet = false
local save_Sound_EnableErrorSpeech
local save_UIErrorsFrame_OnEvent
local huge = math.huge
local frame = CreateFrame("Frame")

local function NOOP() end

local function Change(n)
	count = max(count + n, 0)
	if count > 0 then
		if not quiet then
			frame:RegisterEvent("PLAYER_LOGOUT")
			frame:RegisterEvent("EXECUTE_CHAT_LINE")
			save_Sound_EnableErrorSpeech = GetCVar("Sound_EnableErrorSpeech")
			SetCVar("Sound_EnableErrorSpeech", 0)	
			save_UIErrorsFrame_OnEvent = UIErrorsFrame:GetScript('OnEvent')
			UIErrorsFrame:SetScript('OnEvent', NOOP)
			quiet = true
		end
	elseif quiet then
		frame:UnregisterEvent("PLAYER_LOGOUT")
		frame:UnregisterEvent("EXECUTE_CHAT_LINE")
		SetCVar("Sound_EnableErrorSpeech", save_Sound_EnableErrorSpeech)
		UIErrorsFrame:SetScript('OnEvent', save_UIErrorsFrame_OnEvent)
		quiet = false
	end
end

frame:SetScript('OnEvent', function(_, event, line)
	if event == 'EXECUTE_CHAT_LINE' then
		if strsub(line, 1, 10) == "/stopmacro" then
			Change(-huge)
		else
			Change(-1)
		end
	elseif event == 'PLAYER_LOGOUT' then
		Change(-huge)
	end
end)

SLASH_QUIETCAST1 = "/quietcast"
SLASH_QUIETCAST2 = "/quiet"
SLASH_QUIETCAST1 = "/qc"
SlashCmdList.QUIETCAST = function(arg)
	local arg = strlower(SecureCmdOptionParse(arg))
	if arg == "on" then
		Change(huge)
	elseif arg == "off" then
		Change(-huge)
	elseif arg == "help" then
		print([==[QuietCast help:
- /quietcast on: disable all errors messages until the next /stopmacro or /quietcast off.
- /quietcast off: enable all errors messages.
- /quietcast N: ignore error messages for the next N macro commands.
- /quietcast help: display this help.
Command aliases: /quiet, /qc.
/quietcast accepts macro conditionals, e.g. /qc [noexists]3; 2
]==])
	else
		Change(tonumber(arg) or 1)
	end
end

